package pizza;

public class OrderSummary {
	private Customer customer;
	
	public OrderSummary(Customer customer) {
		this.setCustomer(customer);
	}

	private void setCustomer(Customer customer) {
		this.customer = customer;
	}

	private Customer getCustomer() {
		return customer;
	}
	
	public String getOrderSummary() {
		String result = "Order Record for " + customer.getName() + "\n";
		for (OrderedPizza order : customer.getOrderedPizzas()) {
			result += String.format("   %2d %-20s %6d\n", order.getQuantity(),
					order.getPizza().getName(), order.calculatePrize());
		}
		result += String.format("   %-23s %6d\n", "Total", customer.getTotalPrice());
		result += String.format("   %-23s %6d\n", "Free Normal Pizzas", customer.getPizzaPoints() / 100);
		return result;
	}
}
