package pizza;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.DefaultComboBoxModel;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.LayoutStyle;

public class OrderWindow extends JFrame implements ActionListener
{
	private static final long serialVersionUID = 1L;

	JButton addBtn;
	private JScrollPane jScrollPane1;
	JTextField nameField;
	JButton newBtn;
	JTextArea outputArea;
	JComboBox pizzaCombo;
	JTextField quantityField;

	private UIHandler uihandler;

	public OrderWindow(List<Pizza> todaysPizzas) {
		uihandler = new UIHandler();
		createContents();
		fillTodaysPizza(todaysPizzas);
	}

	private void fillTodaysPizza(List<Pizza> todaysPizzas) {	
		pizzaCombo.setModel(new DefaultComboBoxModel(UIHandler.createTodaysPizzas(todaysPizzas)));
	}

	private void createContents() {
		newBtn = new JButton();
		newBtn.setText(UIHandler.getTxtNewbtn());
		newBtn.addActionListener(this);

		JLabel label1 = new JLabel();
		label1.setText(UIHandler.getTxtCustomername());

		nameField = new JTextField();

		JLabel label2 = new JLabel();
		label2.setText(UIHandler.getTxtAvailablepizzas());

		pizzaCombo = new JComboBox();

		JLabel label3 = new JLabel();
		label3.setText(UIHandler.getTxtQuantity());

		quantityField = new JTextField();

		addBtn = new JButton();
		addBtn.setText(UIHandler.getTxtAdd());
		addBtn.addActionListener(this);

		JLabel label4 = new JLabel();
		label4.setText(UIHandler.getTxtOrderoutput());

		outputArea = new JTextArea();
		outputArea.setColumns(20);
		outputArea.setEditable(false);
		outputArea.setFont(new java.awt.Font(Font.MONOSPACED, 0, 12));
		outputArea.setRows(5);
		jScrollPane1 = new JScrollPane();
		jScrollPane1.setViewportView(outputArea);

		GroupLayout layout = new GroupLayout(getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(
				layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addGroup(layout.createSequentialGroup()
						.addContainerGap()
						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
								.addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 513, Short.MAX_VALUE)
								.addGroup(layout.createSequentialGroup()
										.addComponent(newBtn)
										.addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
										.addComponent(label1)
										.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(nameField, GroupLayout.DEFAULT_SIZE, 254, Short.MAX_VALUE))
										.addGroup(layout.createSequentialGroup()
												.addComponent(label2)
												.addGap(3, 3, 3)
												.addComponent(pizzaCombo, 0, 215, Short.MAX_VALUE)
												.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
												.addComponent(label3)
												.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
												.addComponent(quantityField, GroupLayout.PREFERRED_SIZE, 46, GroupLayout.PREFERRED_SIZE)
												.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
												.addComponent(addBtn))
												.addComponent(label4))
												.addContainerGap())
		);
		layout.setVerticalGroup(
				layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addGroup(layout.createSequentialGroup()
						.addContainerGap()
						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
								.addComponent(newBtn)
								.addComponent(label1)
								.addComponent(nameField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
								.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
										.addComponent(pizzaCombo, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
										.addComponent(label2)
										.addComponent(addBtn)
										.addComponent(quantityField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
										.addComponent(label3))
										.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(label4)
										.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE)
										.addContainerGap())
		);

		pack();

		setTitle(UIHandler.getTxtTitle());

		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLocationRelativeTo(null);
	}

	public void actionPerformed(ActionEvent e) {
		if (newBtn.equals(e.getSource())) {
			uihandler.newCustomer();
		} else if (addBtn.equals(e.getSource())) {
			String errstr = uihandler.addOrder(nameField.getText().trim(), pizzaCombo.getSelectedIndex(), quantityField.getText(), (Pizza) pizzaCombo.getSelectedItem());
			if (errstr != null) {
				JOptionPane.showMessageDialog(this, errstr,
						"Error", JOptionPane.ERROR_MESSAGE);
				return;
			}
		}
		
		nameField.setText(uihandler.getName());
		pizzaCombo.setSelectedIndex(uihandler.getSelectedPizza());
		quantityField.setText("" + uihandler.getQuantity());
		outputArea.setText(uihandler.getOutput());
		nameField.requestFocusInWindow();
	}
}
