package pizza;

public class OrderedPizza
{
	private final int quantity;
	private final Pizza pizza;

	public OrderedPizza(int quantity, Pizza pizza) {
		this.quantity = quantity;
		this.pizza = pizza;
	}

	public Pizza getPizza() {
		return pizza;
	}

	public int getQuantity() {
		return quantity;
	}
	
	public int calculatePrize() {
		return (int)(pizza.getPriceInCent() * pizza.getPriceMultiplicator() * quantity);
	}
	
	public int calculatePoints() {
		return pizza.getPoints() * quantity;
	}
}
