package pizza;

import java.util.List;

public class UIHandler {
	private static final String txt_newBtn = "New Customer";
	private static final String txt_customerName = "Customer Name:";
	private static final String txt_availablePizzas = "Available Pizzas:";
	private static final String txt_quantity = "Quantity:";
	private static final String txt_add = "Add";
	private static final String txt_orderOutput = "Order Output:";
	private static final String txt_title = "FooBars Pizza";
	
	private Customer customer;
	private String name;
	private int selectedPizza;
	private int quantity;
	private String output;
	
	public void newCustomer() {
		setName("");
		setSelectedPizza(0);
		setQuantity(1);
		setOutput("");
		customer = null;
	}
	
	public String addOrder(String name, int selection, String quantity, Pizza pizza) {
		int quant = 0;
		try {
			quant = Integer.parseInt(quantity.trim());
		} catch (NumberFormatException ex) {
			quant = 0;
		}
		
		return addOrder(name, selection, quant, pizza);
	}
	
	public String addOrder(String name, int selection, int quantity, Pizza pizza) {
		String errstr = Validator.checkValid(name, selection, quantity);
		if (errstr != null)
			return errstr;

		if (customer == null)
			customer = new Customer(name);
		else
			customer.setName(name);
		customer.addOrder(new OrderedPizza(quantity, pizza));
		
		setName(name);
		setSelectedPizza(selection);
		setQuantity(quantity);
		setOutput(customer.getOrderSummary());
		return null;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setSelectedPizza(int selectedPizza) {
		this.selectedPizza = selectedPizza;
	}

	public int getSelectedPizza() {
		return selectedPizza;
	}

	public void setQuantity(int quantity) {
		this.quantity = quantity;
	}

	public int getQuantity() {
		return quantity;
	}

	public void setOutput(String output) {
		this.output = output;
	}

	public String getOutput() {
		return output;
	}

	public static Object[] createTodaysPizzas(List<Pizza> todaysPizzas) {
		Object a[] = new Object[todaysPizzas.size()];
		for (int i=0; i < a.length; ++i) {
			a[i] = todaysPizzas.get(i);
		}
		return a;
	}

	public static String getTxtNewbtn() {
		return txt_newBtn;
	}

	public static String getTxtCustomername() {
		return txt_customerName;
	}

	public static String getTxtAvailablepizzas() {
		return txt_availablePizzas;
	}

	public static String getTxtQuantity() {
		return txt_quantity;
	}

	public static String getTxtAdd() {
		return txt_add;
	}

	public static String getTxtOrderoutput() {
		return txt_orderOutput;
	}

	public static String getTxtTitle() {
		return txt_title;
	}
}
