package pizza;

public class Validator {
	public static String checkValid(String name, int selection, String quantity) {
		int quant = 0;
		try {
			quant = Integer.parseInt(quantity.trim());
		} catch (NumberFormatException ex) {
			quant = 0;
		}
		
		return checkValid(name, selection, quant);
	}
	
	public static String checkValid(String name, int selection, int quantity) {
		if (isEmpty(name))
			return "Set customer name first!";
		if (!checkSelection(selection))
			return "No pizza selected!";
		if (!checkQuantity(quantity))
			return "Quantity must be greate than 0!";
		return null;
	}
	
	private static boolean isEmpty(String str) {
		return str.trim().isEmpty();
	}
	
	private static boolean checkSelection(int i) {
		return (i >= 0);
	}
	
	private static boolean checkQuantity(int i) {
		return (i > 0);
	}
}
